/*
 *  matrix44.cpp
 *  RayTracer
 *
 *
 *  Modified by Rick Skarbez for COMP 575 - Fall 2007
 *  Originally created by Eric Bennett on 8/8/06.
 */


#include "matrix44.h"

matrix44::matrix44()
{
	setIdentity();
}

matrix44::matrix44(double **a)
{
	int i, j;
	for(i=0;i<4;i++)
		for(j=0;j<4;j++)
			m[i][j] = a[i][j];
}

matrix44::matrix44(double m00, double m01, double m02, double m03,
			 double m10, double m11, double m12, double m13,
			 double m20, double m21, double m22, double m23,
			 double m30, double m31, double m32, double m33)
{
	m[0][0] = m00; m[0][1] = m01; m[0][2] = m02; m[0][3] = m03;
	m[1][0] = m10; m[1][1] = m11; m[1][2] = m12; m[1][3] = m13;
	m[2][0] = m20; m[2][1] = m21; m[2][2] = m22; m[2][3] = m23;
	m[3][0] = m30; m[3][1] = m31; m[3][2] = m32; m[3][3] = m33;
}

void matrix44::setTranslate(double x, double y, double z)
{
	// Fill in yourselves. -RTS
}

void matrix44::setScale(double x, double y, double z)
{
	// Fill in yourselves. -RTS
}

void matrix44::setRotateX(double theta)
{
	// Fill in yourselves. -RTS
}

void matrix44::setRotateY(double theta)
{
	// Fill in yourselves. -RTS
}

void matrix44::setRotateZ(double theta)
{
	// Fill in yourselves. -RTS
}

void matrix44::setIdentity()
{
	m[0][0] = 1; m[0][1] = 0; m[0][2] = 0; m[0][3] = 0;
	m[1][0] = 0; m[1][1] = 1; m[1][2] = 0; m[1][3] = 0;
	m[2][0] = 0; m[2][1] = 0; m[2][2] = 1; m[2][3] = 0;
	m[3][0] = 0; m[3][1] = 0; m[3][2] = 0; m[3][3] = 1;
}

void matrix44::setEmpty()
{
	int i, j;
	for(i=0;i<4;i++)
		for(j=0;j<4;j++)
			m[i][j] = 0;
}

void matrix44::multiply(matrix44 &A, matrix44 &B)
{
	int i, j;
	
	for(i=0;i<4;i++)
		for(j=0;j<4;j++)
			m[i][j] = A.m[i][0]*B.m[0][j] + A.m[i][1]*B.m[1][j] + A.m[i][2]*B.m[2][j] + A.m[i][3]*B.m[3][j];
}

void matrix44::transpose(matrix44 &A)
{
	int i,j;
	for(i=0;i<4;i++)
		for(j=0;j<4;j++)
			m[i][j] = A.m[j][i];
}

void matrix44::print()
{
	//std::cout << "Matrix Contains: " << m[0][0];
	// << " " << m[0][1] << " " << m[0][2] << " " << m[0][3] "\n";
	printf("\nMatrix Contains: %6.3f %6.3f %6.3f %6.3f\n", m[0][0], m[0][1], m[0][2], m[0][3]);
	printf("               : %6.3f %6.3f %6.3f %6.3f\n", m[1][0], m[1][1], m[1][2], m[1][3]);
	printf("               : %6.3f %6.3f %6.3f %6.3f\n", m[2][0], m[2][1], m[2][2], m[2][3]);
	printf("               : %6.3f %6.3f %6.3f %6.3f\n\n", m[3][0], m[3][1], m[3][2], m[3][3]);
}