/*
 *  matrix44.h
 *  RayTracer
 *
 *
 *  Modified by Rick Skarbez for COMP 575 - Fall 2007
 *  Originally created by Eric Bennett on 8/8/06.
 */


#ifndef MATRIX44_H
#define MATRIX44_H

#define PI 3.1415926

#include <math.h>
#include <iostream>
#include <stdio.h>

class matrix44
{
public:
	double m[4][4];
	
	matrix44();
	matrix44(double **a);
	matrix44(double m00, double m01, double m02, double m03,
		  double m10, double m11, double m12, double m13,
		  double m20, double m21, double m22, double m23,
		  double m30, double m31, double m32, double m33);
	
	void setIdentity();
	void setEmpty();
	
	void transpose(matrix44 &A);
	void multiply(matrix44 &A, matrix44 &B);
	
	void print();
	
	// You need to fill in the bodies of these functions yourselves. -RTS
	void setTranslate(double x, double y, double z);
	void setScale(double x, double y, double z);
	void setRotateX(double theta);
	void setRotateY(double theta);
	void setRotateZ(double theta);	
};

#endif