/*
 *  ray3D.cpp
 *  RayTracer
 *
 *  Modified by Rick Skarbez for COMP 575 - Fall 2007
 *  Originally created by Eric Bennett on 8/8/06.
 */

#include "ray3D.h"

void ray3D::intersect(object *objects)
{
	object *currOb = objects;
	
	while(currOb != NULL)
	{
		currOb->intersect(*this);
		currOb = currOb->nextObject;
	}
	
	if(ob!=NULL)
	{
		hitPoint.set(0,0,0);
		hitPoint.isPoint = true;
		hitPoint.scale(direction,distance);
		hitPoint.plus(start);
	}
}

void ray3D::reset()
{
	start.set(0,0,0);
	start.isPoint = true;
	direction.set(0,0,0);
	direction.isPoint = false;
	ob = NULL;
	distance = 99999999.0;
	entering = true;
}

color ray3D::shade(int recLevel, int maxRec, color &backColor, double currRIndex, object *objects, light *lights)
{
	if(ob==NULL)
		return backColor;
	else
		return ob->shade(*this, recLevel, maxRec, backColor, currRIndex, objects, lights);
}