/*
 *  ray3D.h
 *  RayTracer
 *
 *
 *  Modified by Rick Skarbez for COMP 575 - Fall 2007
 *  Originally created by Eric Bennett on 8/8/06.
 */


#ifndef RAY3D_H
#define RAY3D_H

#include "object.h"
#include "color.h"
#include "light.h"

// Eliminates include looping
class object;

class ray3D
{
public:
	vector3D start;
	vector3D direction;
	vector3D hitNormal;
	vector3D hitPoint;
	double distance;
	object *ob;
	bool entering;
	
	void intersect(object *objects);
	color shade(int recLevel, int maxRec, color &backColor, double currRIndex, object *objects, light *lights);
	void reset();
};

#endif