/*
 *  vector3D.h
 *  RayTracer
 *
 *
 *  Modified by Rick Skarbez for COMP 575 - Fall 2007
 *  Originally created by Eric Bennett on 8/8/06.
 */


#ifndef VECTOR3D_H
#define VECTOR3D_H

#include <iostream>
#include <math.h>
#include "matrix44.h"

class vector3D
{
public:
	double x, y, z;
	bool isPoint;
	
	vector3D();
	vector3D(double newx, double newy, double newz, bool newPoint);
	vector3D(vector3D &v);
	
	double dot(vector3D &B);
	double dot(double Bx, double By, double Bz);
	double dot(vector3D &A, vector3D &B);
	
	void cross(vector3D &A, vector3D &B);
	
	double length();
	void normalize();
	void normalize(vector3D &A); 
	
	void scale(double s);
	void scale(vector3D &A, double s);
	void plus(vector3D &B);
	void plus(vector3D &A, vector3D &B);
	void minus(vector3D &B); 
	void minus(vector3D &A, vector3D &B);
	
	void set(double newx, double newy, double newz);
	
	void multiply(matrix44 &A);
	void multiply(matrix44 &A, vector3D &V);
	
	void print();
};

#endif
